![docs.rs](https://img.shields.io/docsrs/microrm)

microrm is a simple object relational manager (ORM) for sqlite.

Unlike many fancier ORM systems, microrm is designed to be lightweight, both in
terms of runtime overhead and developer LoC. By necessity, it sacrifices
flexibility towards these goals, and so can be thought of as more opinionated
than, say, [SeaORM](https://www.sea-ql.org/SeaORM/) or
[Diesel](https://diesel.rs/). Major limitations of microrm are:
- lack of database migration support
- limited vocabulary for describing object-to-object relations

microrm pushes the Rust type system somewhat to provide better ergonomics, so
the MSRV is currently 1.75. Don't be scared off by the web of traits in the
`schema` module --- you should never need to interact with any of them!
